from math import *
import os


### Usage : Remplacer "CC_KLM" par "01_111" (ou la classe que l'on veut) et run python3 ###


iter=1
f=open("OUTCAR",'r')

lstress,liter,lE,liste,lconfig=[],[],[],[],[]


while 1:
    t=f.readline()
    if t=="":
        break
    
    lst=t.split()

    try:
        if lst[1]=="Iteration":
            mdr=len(lst[2])
            if mdr==2:
                iter=(lst[2][0])
            if mdr==3:
                iter=(lst[2][0]+lst[2][1])
            if mdr==4:
                iter=(lst[2][0]+lst[2][1]+lst[2][2])
                
#            print(iter)
            


        if lst[0]=="in" and lst[1]=="kB":
            if int(iter)>1:
                lstress.append(str(float(lst[2])/1600)+" "+str(float(lst[3])/1600)+" "+str(float(lst[4])/1600)+" "+str(float(lst[6])/1600)+" "+str(float(lst[7])/1600)+" "+str(float(lst[5])/1600)+" "+str(iter))  ### /1600 pour mettre en eV/A^3 ###
                liter.append(iter)

        if lst[0]=="POSITION" and lst[1]=="TOTAL-FORCE" and int(iter)>1: ### On ne prend pas la première itération ###
            t=f.readline()
            #lconfig=[]
            while 1:
                t=f.readline()
                #print(t)
                if lst[0][1]=="-":
                    break
                lst=t.split()
                
                lconfig.append(lst[0]+" "+lst[1]+" "+lst[2]+" "+lst[3]+" "+lst[4]+" "+lst[5]+" "+str(iter))
                #print("ici",lconfig)
                
        if lst[0]=="FREE" and lst[1]=="ENERGIE" and lst[2]=="OF": ### Ligne FREE ENERGIE OF THE ION-ELECTRON SYSTEM (eV) ###
            t=f.readline()
            t=f.readline()
            t=f.readline()
            t=f.readline()
            #print(t)
            lst=t.split()
            liste.append(iter)
            liste.append(lst[6])
            lE.append(liste)
            #print(lE)
            liste=[]
                                
    except IndexError:
        pass

###################### Nombre d'atomes dans la boîte (POSCAR) ###########
g=open("POSCAR",'r')
u=g.readline()
u=g.readline()
u=g.readline()
u=g.readline()
u=g.readline()
u=g.readline()

toto=u.split()
if toto[0]=="C" :
    u=g.readline()
    titi=u.split()
    Nb_at=float(titi[0])+float(titi[1])
    Nb_C=float(titi[0])
    Nb_Fe=float(titi[1])
    Nb_elem=2   ### Nombre d'éléments (pour écrire première ligne) #######

if toto[0]=="Fe":
    u=g.readline()
    titi=u.split()
    Nb_at=int(titi[0])
    Nb_Fe=int(titi[0])
    Nb_C=0
    Nb_elem=1
    
else:
    Nb_at=int(toto[0])
    Nb_Fe=int(toto[0])
    Nb_C=0
    Nb_elem=1
##########################################################################

### Nb de steps MD (INCAR) ##############################################    
i=0
h=open("INCAR",'r')
while i<15:
    j=h.readline()
    i=i+1

tutu=j.split()
#print(tutu)
try:
    str_stepsMD=tutu[0][4]+tutu[0][5]+tutu[0][6] ### Pour un nombre de steps max de 999 (sinon rajouter tutu[0][7]) ###
except IndexError:
    str_stepsMD=tutu[0][4]+tutu[0][5]

Steps_MD= int(str_stepsMD)

while 1:              ### ISPIN (INCAR) ###################################
    j=h.readline()
    if j=='':
        break
    lst2=j.split()
    try:
        if lst2[0]=="ISPIN":
            ISPIN=lst2[2]
    except IndexError:
#        print("Attention, il est peut-etre ecrit ISPIN=2 sans espace...")
        pass



############################################################################


j=len(lE)-1     ### On commence de la fin de la liste (pour avoir les dernières itérations) ###
it=int(lE[j][0])
#print(it)
a=5             ####### Prendre toutes les a config ###########
Nb_it=(len(lE))

lEfinal=[]
temp=0.0

while j>-1:
#while j<Steps_MD
    
    if int(lE[j][0])==it and it>1:
#        print(it)
        it=it-a
       # print(lE[j][1])
        temp=(lE[j][1])
        lEfinal.append(temp)
#        print(lE[j][1])
    j=j-1

lEfinal.reverse()
#print(lEfinal)

pipo=lconfig[1].split()
#print(pipo[0])

k=0
it=2


while k<len(lEfinal):   ### Écriture du fichier format database ### 
    
    if int(k+1)<10:
         fichier_out= "02_111_00000"+str(k+1)+".poscar"
         fo=open(fichier_out,'w')
         if Nb_elem==2:
             E2=float(lEfinal[k])+(Nb_Fe*8.238111398)
             E3=float(E2)+(Nb_C*8.39753165)
             fo.write("111 2 C 12 Fe 26 "+lEfinal[k]+" "+str(E2)+" "+str(E3)+"\n")     
             
         if Nb_elem==1:
             E2=float(lEfinal[k])+(Nb_Fe*8.238111398)
             E3=E2   ### 0 atomes de C            
             fo.write("111 1 Fe 26 "+lEfinal[k]+" "+str(E2)+" "+str(E3)+"\n")   
             
         fo.write("1.00000000 \n")
         boite=open("POSCAR",'r')
         tboite=boite.readline()
         tboite=boite.readline()
         fo.write(boite.readline())
         fo.write(boite.readline())
         fo.write(boite.readline())
         #fo.write(boite.readline())
         #fo.write(boite.readline())
         if Nb_elem==1:
             fo.write(str(int(Nb_Fe))+"\n")
         if Nb_elem==2:
             fo.write(str(int(Nb_C))+" "+str(int(Nb_Fe))+"\n")           
         fo.write("Cartesian \n")
         d=0
         while d<len(lconfig):       ### écriture des positions ###
             pipo=lconfig[d].split()
             if int(pipo[6])==it:
                 fo.write(pipo[0]+" "+pipo[1]+" "+pipo[2]+" \n")

             d=d+1

         fo.write("\n")
        
         e=0
         while e<len(lconfig):        ### écriture des forces ###
             pipo=lconfig[e].split()
             if int(pipo[6])==it:
                 fo.write(pipo[3]+" "+pipo[4]+" "+pipo[5]+" \n")

             e=e+1

         fo.write("\n")
         
         gh=0
         while gh<len(lstress):        ### écriture des forces ###
             pipon=lstress[gh].split()
             if int(pipon[6])==it:
                 fo.write(pipon[0]+" "+pipon[1]+" "+pipon[2]+" "+pipon[3]+" "+pipon[4]+" "+pipon[5]+" \n")

             gh=gh+1

         fo.write("\n")
         fo.write(ISPIN)

             
    if int(k+1)>9 and int(k+1)<100:
         fichier_out= "02_111_0000"+str(k+1)+".poscar"
         fo=open(fichier_out,'w')
         if Nb_elem==2:
             E2=float(lEfinal[k])+(Nb_Fe*8.238111398)
             E3=float(E2)+(Nb_C*8.39753165)
             fo.write("111 2 C 12 Fe 26 "+lEfinal[k]+" "+str(E2)+" "+str(E3)+"\n")             
         if Nb_elem==1:
             E2=float(lEfinal[k])+(Nb_Fe*8.238111398)
             E3=E2   ### 0 atomes de C            
             fo.write("111 1 Fe 26 "+lEfinal[k]+" "+str(E2)+" "+str(E3)+"\n")   
             
         fo.write("1.00000000 \n")
         boite=open("POSCAR",'r')
         tboite=boite.readline()
         tboite=boite.readline()
         fo.write(boite.readline())
         fo.write(boite.readline())
         fo.write(boite.readline())
         #fo.write(boite.readline())
         #fo.write(boite.readline())
         if Nb_elem==1:
             fo.write(str(int(Nb_Fe))+"\n")
         if Nb_elem==2:
             fo.write(str(int(Nb_C))+" "+str(int(Nb_Fe))+"\n")             

         fo.write("Cartesian \n")
         d=0
         while d<len(lconfig):       ### écriture des positions ###
             pipo=lconfig[d].split()
             if int(pipo[6])==it:
                 fo.write(pipo[0]+" "+pipo[1]+" "+pipo[2]+" \n")

             d=d+1

         fo.write("\n")
        
         e=0
         while e<len(lconfig):        ### écriture des forces ###
             pipo=lconfig[e].split()
             if int(pipo[6])==it:
                 fo.write(pipo[3]+" "+pipo[4]+" "+pipo[5]+" \n")

             e=e+1

         fo.write("\n")
         gh=0
         while gh<len(lstress):        ### écriture des forces ###
             pipon=lstress[gh].split()
             if int(pipon[6])==it:
                 fo.write(pipon[0]+" "+pipon[1]+" "+pipon[2]+" "+pipon[3]+" "+pipon[4]+" "+pipon[5]+" \n")

             gh=gh+1         

         fo.write("\n")
         fo.write(ISPIN)

    if int(k+1)>99:
         fichier_out= "02_111_000"+str(k+1)+".poscar"
         fo=open(fichier_out,'w')
         if Nb_elem==2:
             E2=float(lEfinal[k])+(Nb_Fe*8.238111398)
             E3=float(E2)+(Nb_C*8.39753165)
             fo.write("111 2 C 12 Fe 26 "+lEfinal[k]+" "+str(E2)+" "+str(E3)+"\n")             
         if Nb_elem==1:
             E2=float(lEfinal[k])+(Nb_Fe*8.238111398)
             E3=E2   ### 0 atomes de C            
             fo.write("111 1 Fe 26 "+lEfinal[k]+" "+str(E2)+" "+str(E3)+"\n")
             

         fo.write("1.00000000 \n")
         boite=open("POSCAR",'r')
         tboite=boite.readline()
         tboite=boite.readline()
         fo.write(boite.readline())
         fo.write(boite.readline())
         fo.write(boite.readline())
         #fo.write(boite.readline())
         #fo.write(boite.readline())
         if Nb_elem==1:
             fo.write(str(int(Nb_Fe))+"\n")
         if Nb_elem==2:
             fo.write(str(int(Nb_C))+" "+str(int(Nb_Fe))+"\n")              
         fo.write("Cartesian \n")
         d=0
         while d<len(lconfig):       ### écriture des positions ###
             pipo=lconfig[d].split()
             if int(pipo[6])==it:
                 fo.write(pipo[0]+" "+pipo[1]+" "+pipo[2]+" \n")

             d=d+1

         fo.write("\n")
        
         e=0
         while e<len(lconfig):        ### écriture des forces ###
             pipo=lconfig[e].split()
             if int(pipo[6])==it:
                 fo.write(pipo[3]+" "+pipo[4]+" "+pipo[5]+" \n")

             e=e+1

         fo.write("\n")
         
         gh=0
         while gh<len(lstress):        ### écriture des forces ###
             pipon=lstress[gh].split()
             if int(pipon[6])==it:
                 fo.write(pipon[0]+" "+pipon[1]+" "+pipon[2]+" "+pipon[3]+" "+pipon[4]+" "+pipon[5]+" \n")

             gh=gh+1  
             
         fo.write("\n")
         fo.write(ISPIN)
         
    k=k+1
    it=it+a
